package common.bluray;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import muxer.MuxManager;

import common.DiskFinder;
import common.DiskStream;
import common.Job;
import common.StreamDescriptor;
import common.VideoStreamDescriptor;
import common.bluray.PlayList.Branch;

import demux.ts.M2tsRawDemuxer;

public class PlayListAnalyzer {
	public static final String BLURAY_PLAYLIST_EXT=".mpls";
	
	
	public static void main(String args[]) {
		PlayListAnalyzer analyzer=new PlayListAnalyzer();
		try {
			//List<Branch> list=analyzer.getBranchList("m:/00035.mpls");
			analyzer.getTitles(new File("C:/internet/PLAYLIST"),true);
			//System.out.println(list);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public DiskStream[] getTitles(File playListDir, boolean filter) throws IOException {
		return getTitles(playListDir.listFiles(),filter);
	}
	public DiskStream[] getTitles(File playListArray[], boolean filter) throws IOException {
		TreeMap<Long, DiskStream>map=new TreeMap<Long, DiskStream>();
		
		for (int p=0;p<playListArray.length;p++) {
			PlayList playList=new PlayList();
			playList.parse(playListArray[p]);
			List<Branch> list=playList.getBranchList();
			
			for (int j=0;j<playList.getBranchSize();j++) {
				File files[]=new File[list.size()];
				
				for (int i=0;i<list.size();i++) {
					//files[i]=new File(streamDir,list.get(i).getFileName());
					File bdmvDir=playListArray[p].getParentFile().getParentFile();
					File streamDir=new File(bdmvDir,"STREAM");
					Branch branch=list.get(i);
					
					files[i]=new File(streamDir, branch.getFileName(j));
				}
				int index=playList.getBranchSize()==1?DiskStream.NO_INDEX:j;
				
				DiskStream diskStream=new DiskStream(files, playList.getLength(), playListArray[p], playList.getChapters(), index);
				
				
				for (long l=playList.getLength()*10 + index;diskStream != null;l++) {
					diskStream=map.put(Long.valueOf(l), diskStream);
				}
			}
		}
		List<DiskStream> list;
		if (filter) {
			list=new ArrayList<DiskStream>(map.size());
			for (Iterator<DiskStream> i=map.values().iterator();i.hasNext();) {
				DiskStream diskStream=i.next();
				if (diskStream.getLength() >= DiskFinder.MIN_LENGTH && diskStream.getLength() <= DiskFinder.MAX_LENGTH) {
					list.add(diskStream);
				}
			}
		} else {
			list=new ArrayList<DiskStream>(map.values());
		}
		if (list.size()==1) {
			return new DiskStream[]{list.get(0)};
		}
		List<DiskStream> fullHdList;
		if (filter) {
			fullHdList=new ArrayList<DiskStream>(list.size());
			for (int i=0;i<list.size();i++) {
				if (isMainTitle(list.get(i))) {
					fullHdList.add(list.get(i));
				}
			}
		} else {
			fullHdList=list;
		}
		DiskStream diskStreamArray[]=new DiskStream[fullHdList.size()];
		fullHdList.toArray(diskStreamArray);
		return diskStreamArray;
	}
	
	private boolean isMainTitle(DiskStream diskStream) throws IOException {
		File files[]=diskStream.getFiles();
		if (files.length > 1) {
			//Saw this in HellBoy.  Same file repeated over and over
			if (files[files.length-1].equals(files[files.length-2])) {
				return false;
			}
		}
		MuxManager muxManager=new MuxManager(new M2tsRawDemuxer());
		diskStream.setJob(new Job());
		Map<Integer, StreamDescriptor> streamMap=muxManager.getStreamDescriptorMap(diskStream);
		
		for (Iterator<StreamDescriptor> i=streamMap.values().iterator();i.hasNext();) {
			StreamDescriptor streamDescriptor=i.next();
			if (streamDescriptor instanceof VideoStreamDescriptor) {
				VideoStreamDescriptor videoStreamDescriptor=(VideoStreamDescriptor)streamDescriptor;
				if (videoStreamDescriptor.getHeight()==1080) {
					return true;
				}
			}
		}
			
		return false;
	}
}
