package muxer.demux;

import java.io.IOException;

import common.StreamDescriptor;
import common.packet.Packet;
import common.packet.PesPacket;

import demux.pes.PesUtil;

public class VideoPesAudioRawDemuxerMuxer extends RawDemuxerMuxer {
	private PesUtil pesUtil=new PesUtil();
	
	public VideoPesAudioRawDemuxerMuxer(String fileName) {
		super(fileName);
	}
	protected String getFileName(StreamDescriptor streamDescriptor) {
		String fileName=fileNamePrefix + '_' + Integer.toHexString(streamDescriptor.getStreamId())+streamDescriptor.getFileNameExtension();
		if (streamDescriptor.getClassification()==StreamDescriptor.CLASSIFICATION_VIDEO) {
			fileName +=".mpg";
		}
		return fileName;
	}
	protected void write(Packet packet, StreamData data) throws IOException {
		if (packet instanceof PesPacket && data.classification==StreamDescriptor.CLASSIFICATION_VIDEO) {
			pesUtil.writePacket((PesPacket)packet, data.out);
		} else {
			super.write(packet, data);
		}
	}	
}
